local mod = RegisterMod("Free Shipping", 1);
local item = Isaac.GetItemIdByName("Free Shipping")

local debug = false;
local game = Game();

function mod:start()
	if game:GetFrameCount() == 0 then
		if debug then
			Isaac.ExecuteCommand("spawn 5.100."..item);
		end
	end
end

function mod:useItem()
	local	player = Isaac.GetPlayer(0);
	
	local useValue = 15;

	if player:HasCollectible(CollectibleType.COLLECTIBLE_STEAM_SALE) then
		useValue = 7;
	end

	if player:GetNumCoins() >= useValue then
		
		if Random() % 10 == 0 then
			useValue = 7;
		end

		player:AddCoins(-useValue);

		local spawn_pos = game:GetRoom():FindFreePickupSpawnPosition(player.Position, 1, true);

		local shop_item = game:GetItemPool():GetCollectible(ItemPoolType.POOL_SHOP, true, game:GetSeeds():GetStartSeed());
		Isaac.Spawn(EntityType.ENTITY_PICKUP, PickupVariant.PICKUP_COLLECTIBLE, shop_item, spawn_pos, Vector(0.0, 0.0), player);
		
		if Random() % 8 == 0 then
			player:RemoveCollectible(item);
		end
		return true;
	end
end

mod:AddCallback(ModCallbacks.MC_USE_ITEM, mod.useItem, item);
mod:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, mod.start);