local mod = RegisterMod( "Divine Options", 1);
local item = Isaac.GetItemIdByName( "Divine Options" )

local debug = false;
local game = Game();
local hasCostume = false;

function mod:start()
	hasCostume = false;
	if (game:GetFrameCount() == 0) then
		if debug then
			Isaac.ExecuteCommand("spawn 5.100."..item);
		end
	end
end

function mod:update()
	local player = Isaac.GetPlayer(0);

	if (player:HasCollectible(item)) then
	
		if (not hasCostume) then
			player:AddNullCostume(Isaac.GetCostumeIdByPath("gfx/Characters/divine_options.anm2"));
			hasCostume = true;
		end

		local entities = Isaac.GetRoomEntities();

		for i = 1, #entities do
			if entities[i].Type == EntityType.ENTITY_PICKUP and entities[i].Variant == PickupVariant.PICKUP_COLLECTIBLE then
				entities[i]:ToPickup().TheresOptionsPickup = false;
			end
		end
	end
end

mod:AddCallback( ModCallbacks.MC_POST_UPDATE, mod.update);
mod:AddCallback( ModCallbacks.MC_POST_GAME_STARTED, mod.start);