local mod = RegisterMod( "Friendly Bombs", 1);
local item = Isaac.GetItemIdByName( "Friendly Bombs" )

local debug = false;
local game = Game();

function mod:start()
	if game:GetFrameCount() == 0 then
		if debug then
			Isaac.ExecuteCommand("spawn 5.100."..item);
		end
	end
end

function mod:update()

	--Retreive the player
	local player = Isaac.GetPlayer(0);
	
	--If the player has the Friendly Bombs item
	if (player:HasCollectible(item)) then
		local entities = Isaac.GetRoomEntities();
		for i = 1, #entities do
			if entities[i].Type == EntityType.ENTITY_BOMBDROP then
				local range = 95; --Seems somewhat correct
				if entities[i].Variant == BombVariant.BOMB_MR_MEGA or entities[i].Variant == BombVariant.BOMB_BIG or entities[i].Variant == BombVariant.BOMB_POISON_BIG then
					range = 110;
				end
				if player:HasCollectible(CollectibleType.COLLECTIBLE_BOMBER_BOY) and (entities[i].Variant ~= BombVariant.BOMB_TROLL and entities[i].Variant ~= BombVariant.BOMB_SUPERTROLL) then
					range = range * 2;
				end
				if entities[i]:GetSprite():GetFilename() ~= "gfx/friendly_bomb.anm2" then
					if entities[i].Variant ~= BombVariant.BOMB_BIG and entities[i].Variant ~= BombVariant.BOMB_POISON_BIG and not player:HasCollectible(Isaac.GetItemIdByName("Bomber Boy")) then
						if entities[i].Variant ~= BombVariant.BOMB_DECOY and entities[i].Variant ~= BombVariant.BOMB_TROLL and entities[i].Variant ~= BombVariant.BOMB_SUPERTROLL then
							if entities[i].Variant ~= BombVariant.BOMB_BUTT and entities[i].Variant ~= BombVariant.BOMB_MR_MEGA and entities[i].Variant ~= BombVariant.BOMB_BOBBY then
								entities[i]:GetSprite():Load("gfx/friendly_bomb.anm2", true);
							end
						end
					end
				end
				if entities[i].Position:Distance(player.Position) <= range and not player:HasCollectible(CollectibleType.COLLECTIBLE_PYROMANIAC) then
					entities[i]:ToBomb():SetExplosionCountdown(59-entities[i]:GetSprite():GetFrame());
					local sprite = entities[i]:GetSprite();
					local was_at = entities[i]:GetSprite():GetFrame();
					if was_at == 58 then sprite:SetFrame("Pulse", 55); end
					if was_at == 57 then sprite:SetFrame("Pulse", 58); end
					if was_at == 56 then sprite:SetFrame("Pulse", 57); end
					if sprite:GetFrame() == 55 and was_at == 58 then sprite:SetFrame("Pulse", 56); end
				end
				if entities[i].Position:Distance(player.Position) > range and entities[i]:ToBomb().IsFetus then
					entities[i]:ToBomb():SetExplosionCountdown(32-entities[i]:GetSprite():GetFrame());	
				end
			end
		end
	end
end

mod:AddCallback( ModCallbacks.MC_POST_GAME_STARTED, mod.start);
mod:AddCallback( ModCallbacks.MC_POST_UPDATE, mod.update);