local mod = RegisterMod("God's Blessing", 1);
local item = Isaac.GetItemIdByName("God's Blessing");

local debug = false;
local game = Game();
local already_spawned = 0;
local has_costume = false;

function mod:start()
	local player = Isaac.GetPlayer(0);

	if game:GetFrameCount() == 0 then
		has_costume = false;
		if debug then
			Isaac.ExecuteCommand("spawn 5.100."..item);
		end
	end
	already_spawned = player:GetCollectibleNum(item);
end

function mod:update()
	local player = Isaac.GetPlayer(0);
	
	if (player:HasCollectible(item)) then

		if not has_costume then
			has_costume = true;
			player:AddNullCostume(Isaac.GetCostumeIdByPath("gfx/Characters/gods_blessing.anm2"));
		end

		local entities = Isaac.GetRoomEntities();

		if (already_spawned ~= player:GetCollectibleNum(item)) then
			local spawn_pos = game:GetRoom():FindFreePickupSpawnPosition(player.Position, 1, true);
			Isaac.Spawn(EntityType.ENTITY_PICKUP, PickupVariant.PICKUP_HEART, HeartSubType.HEART_BLENDED, spawn_pos, Vector(0, 0), player);
			spawn_pos = game:GetRoom():FindFreePickupSpawnPosition(player.Position, 1, true);
			Isaac.Spawn(EntityType.ENTITY_PICKUP, PickupVariant.PICKUP_HEART, HeartSubType.HEART_BLENDED, spawn_pos, Vector(0, 0), player);
			already_spawned = already_spawned + 1;
		end
		
		for i = 1, #entities do
			if entities[i].Type == EntityType.ENTITY_PICKUP then
				if entities[i].Variant == PickupVariant.PICKUP_HEART then
					if entities[i].SubType == HeartSubType.HEART_FULL then
						if (game:GetLevel():GetCurrentRoom():GetType() ~= RoomType.ROOM_SUPERSECRET) then --prevents bug/lag in womb secret room
							entities[i]:ToPickup():Morph(EntityType.ENTITY_PICKUP, PickupVariant.PICKUP_HEART, HeartSubType.HEART_BLENDED, true);
						end
					end
				end
			end
		end
	else
		already_spawned = 0;
	end
end

function mod:newRoom()
	local player = Isaac.GetPlayer(0);
	
	if (player:HasCollectible(item)) then
		local entities = Isaac.GetRoomEntities();
		
		for i = 1, #entities do
			if entities[i].Type == EntityType.ENTITY_PICKUP then
				if entities[i].Variant == PickupVariant.PICKUP_HEART then
					if entities[i].SubType == HeartSubType.HEART_FULL then
						if (game:GetLevel():GetCurrentRoom():GetType() ~= RoomType.ROOM_SUPERSECRET) then --prevents bug/lag in womb secret room
							entities[i]:ToPickup():Morph(EntityType.ENTITY_PICKUP, PickupVariant.PICKUP_HEART, HeartSubType.HEART_BLENDED, true);
						end
					end
				end
			end
		end
	end
end

mod:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, mod.start);
mod:AddCallback(ModCallbacks.MC_POST_UPDATE, mod.update);
mod:AddCallback(ModCallbacks.MC_POST_NEW_ROOM, mod.newRoom);
