local mod = RegisterMod("Life Insurance", 1);
local item = Isaac.GetItemIdByName("Life Insurance");

local debug = false;
local game = Game();
local has_costume = false;

function mod:start()
	has_costume = false;
	if game:GetFrameCount() == 0 then
		if debug then
			Isaac.ExecuteCommand("spawn 5.100."..item);
		end
	end
end

function mod:update()
	local player = Isaac.GetPlayer(0);
	if not has_costume and player:HasCollectible(item) then
		has_costume = true;
		player:AddNullCostume(Isaac.GetCostumeIdByPath("gfx/Characters/life_insurance.anm2"));
	end
	if player:HasCollectible(item) then
		if player:IsDead() then
			if	player:GetNumCoins() >= 15 then
				player:Revive();
				player:GetEffects():AddCollectibleEffect(CollectibleType.COLLECTIBLE_BOOK_OF_SHADOWS, true);
				player:AddMaxHearts(6-player:GetMaxHearts(), true);
				player:SetFullHearts();
				player:AddSoulHearts(-player:GetSoulHearts());
				player:AddBlackHearts(-player:GetBlackHearts());
				player:AddEternalHearts(-player:GetEternalHearts());
				if (player:GetName() == "???") then
					player:AddSoulHearts(6);
				end
				for i=0,player:GetNumCoins()*2,1 do
					Isaac.Spawn(EntityType.ENTITY_EFFECT, EffectVariant.COIN_PARTICLE, 0, player.Position, Vector(Random() % 11 - 5, Random() % 11 - 5), player);
					if (i % 5 == 0) then
						Isaac.Spawn(EntityType.ENTITY_EFFECT, EffectVariant.GOLD_PARTICLE, 0, player.Position, Vector(Random() % 11 - 5, Random() % 11 - 5), player);
					end
					if (i % 10 == 0) then
						Isaac.Spawn(EntityType.ENTITY_EFFECT, EffectVariant.DIAMOND_PARTICLE, 0, player.Position, Vector(Random() % 11 - 5, Random() % 11 - 5), player);
					end
				end
				player:AddCoins(-player:GetNumCoins());
			end
		end
	end
end

mod:AddCallback(ModCallbacks.MC_POST_UPDATE, mod.update);
mod:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, mod.start);