local mod = RegisterMod("Obsession", 1);
local item = Isaac.GetItemIdByName("Obsession");

local debug = false;
local game = Game();
local picked_up = 0;
local last_update = 0;

function mod:start()
	picked_up = Isaac.GetPlayer(0):GetCollectibleNum(item);
	if game:GetFrameCount() == 0 then
		if debug then
			Isaac.ExecuteCommand("spawn 5.100."..item);
		end
	end
end

function mod:update()
	local player = Isaac.GetPlayer(0);
	if player:HasCollectible(item) then
		if picked_up < player:GetCollectibleNum(item) then
			picked_up = picked_up + 1;

			local total = player:GetNumCoins() + player:GetNumKeys() + player:GetNumBombs();

			if (total % 3 == 1) then
				total = total - 1;
			end

			if (total % 3 == 2) then
				total = total + 1;
			end

			player:AddCoins(2+total/3-player:GetNumCoins());
			player:AddKeys(2+total/3-player:GetNumKeys());
			player:AddBombs(2+total/3-player:GetNumBombs());
		end
		if three_equals() then
			local before_update = last_update;
			if (last_update == 0) then
				player:AddNullCostume(Isaac.GetCostumeIdByPath("gfx/Characters/obsession.anm2"));
			end
			last_update = 3;
			updateStats(3 - before_update);
		else
			if two_equals() then
				if (last_update == 0) then
					player:AddNullCostume(Isaac.GetCostumeIdByPath("gfx/Characters/obsession.anm2"));
				end
				local before_update = last_update;
				last_update = 1;
				updateStats(1 - before_update);
			else
				if (last_update ~= 0) then
					player:TryRemoveNullCostume(Isaac.GetCostumeIdByPath("gfx/Characters/obsession.anm2"));
				end
				local before_update = last_update;
				last_update = 0;
				updateStats(0 - before_update);
			end
		end
	else
		picked_up = 0;
		last_update = 0;
	end
end

function two_equals()
	local player = Isaac.GetPlayer(0);
	return (player:GetNumCoins() == player:GetNumBombs() or player:GetNumCoins() == player:GetNumKeys() or player:GetNumBombs() == player:GetNumKeys());
end

function three_equals()
	local player = Isaac.GetPlayer(0);
	return (player:GetNumCoins() == player:GetNumBombs() and player:GetNumCoins() == player:GetNumKeys());

end

function updateStats(value)
	local player = Isaac.GetPlayer(0);
	if (value ~= 0) then
		player:AddCacheFlags(CacheFlag.CACHE_LUCK + CacheFlag.CACHE_DAMAGE);
		player:EvaluateItems();
	end
end

function mod:cache(playerEntity, cacheFlag)
	if playerEntity:HasCollectible(item) then
		if cacheFlag == CacheFlag.CACHE_LUCK then
			playerEntity.Luck = playerEntity.Luck+last_update;
		end
		if cacheFlag == CacheFlag.CACHE_DAMAGE then	
			playerEntity.Damage = playerEntity.Damage+last_update;
		end
	end
end

mod:AddCallback(ModCallbacks.MC_POST_UPDATE, mod.update);
mod:AddCallback(ModCallbacks.MC_EVALUATE_CACHE, mod.cache);
mod:AddCallback(ModCallbacks.MC_POST_GAME_STARTED, mod.start);
